/* xrll04.c -- test driver for RLL 0,4 encoder/decoder */
 
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <malloc.h>

int rll04_encoder(unsigned char *raw,unsigned char *code,
	int *encodetable,int n);
int rll04_decoder(unsigned char *code,unsigned char *data,
	int *decodetable,int n);
	
void main()
{
	int i;
	unsigned char *raw, *code, *data;
	int *encodetable;
	int *decodetable;
	FILE *intable;
	
/* allocate memory */
	raw = (unsigned char *)calloc(112,sizeof(unsigned char));
	code = (unsigned char *)calloc(126,sizeof(unsigned char));
	data = (unsigned char *)calloc(112,sizeof(unsigned char));
	encodetable = (int *)calloc(256,sizeof(int));
	decodetable = (int *)calloc(512,sizeof(int));

/* load encoder table */	
    intable = fopen("rll04_4.tbl","rt");
    if (!intable) {
        printf("Error! Unable to open rll04_4\n");
        return;
    }
    for (i=0;i<256;i++)
		fscanf(intable,"%d",&encodetable[i]);

/* create decoder table */
	for (i=0;i<256;i++) {
		if (encodetable[i] > 511) {
			printf("Error in encoder!\n");
			exit(1);
		}
		decodetable[encodetable[i]] = i;
	}
/* initialize data for random sequence */
	randomize();
	for (i=0;i<100;i++)
		raw[i] = rand() % 2;
		
	rll04_encoder(raw,code,encodetable,112);
	
    printf("Raw Data:\n");
	for (i=0;i<100;i++)
		printf("%d  ",raw[i]);
	printf("\n\n");
    printf("Encoder:\n");
	for (i=0;i<110;i++)
		printf("%d  ",code[i]);
			
	rll04_decoder(code,data,decodetable,126);

	printf("\n\n");
    printf("Decoder:\n");
	for (i=0;i<100;i++)
		printf("%d  ",data[i]);

	free(decodetable);
	free(encodetable);
	free(data);
	free(code);
	free(raw);	
}

